#include <EEPROM.h>
#include <PCF8574.h>
#include <OneWire.h>
#include <Wire.h>
#include <Adafruit_ADS1015.h>                       // Библиотека для работы с модулями ADS1115 и ADS1015  
#include <TimerOne.h>
#include <MsTimer2.h>
#include <MCP23017.h>

OneWire DS_Cels(6);

#define POWER_MODE  0                                 // режим питания, 0 - внешнее, 1 - паразитное
boolean FlagSensReady;                                // признак готовности данных с датчика температуры
byte  bufData[9];                                     // буфер данных
int   TimeCount;                                      // счетчик времени измерения
byte  Present             = 0;                        // Сигнал наличия термодатчика
float Cels[]              = {0.00};
byte  Flag_Cels           = 0;
#define Cooler              13
/*-----------------------------------------------------------------------------------------------------*/
PCF8574 EXP8574(0x27);
#define OFF     1
#define ON      0

Adafruit_ADS1115 ads; //  0x48                        // Создание объекта ads для общения через него с модулем 

int16_t Adc[] = {0, 0, 0, 0};                         // Переменная для хранения значения АЦП вольтметра (канал 0-3)

#define MCP23017_ADDR     0x20
MCP23017 mcp  = MCP23017(MCP23017_ADDR);
/*-----------------------------------------------------------------------------------------------------*/
#define   Crystall_1      bitClear(W, 4); bitSet(W, 3); Write_A(W); delayMicroseconds(1);
#define   Crystall_2      bitClear(W, 3); bitSet(W, 4); Write_A(W); delayMicroseconds(1);
#define   Screen_Clear    switch (Clr_Scr) {case 0: Clrear_Screen(); Power = 1; Clrear_Screen(); Power = 0; Clr_Scr = 1; break;}
#define   Screen_Clear_0  Power = 1; Clrear_Screen(); Power = 0; Clr_Scr = 1;
/*-----------------------------------------------------------------------------------------------------*/
byte Crystall             = 0;
int  Digit[]              = {0,0,0,0,0,0,0,0,0,0};      // Перем. для вывода на индик.
int  Digit_1[]            = {0,0,0,0,0};                // Перем. для вывода на индик.
int  Out_Dat[]            = {0};
byte Power                = 0;
unsigned char ColStolb_1  = 0;
unsigned char ColPage     = 0;
byte Ind                  = 0;
unsigned char ColSimb     = 0;
unsigned char ColStolb[]  = {0, 18, 32, 46, 60};
int  W                    = 0x1D;     // 0x1C;
byte  Clr_Scr             = 1;                        // 
byte  Cryst, Page, Colum;
/*-----------------------------------------------------------------------------------------------------*/
const float Zc[]          = {0.432, 0.393, 0.415, 0.425};
const float Rc[]          = {0.360, 0.358, 0.362, 0.362};
float Volt[]              = {0, 0, 0, 0};
float Curr[]              = {0, 0, 0, 0};
float Curr_O[]            = {0, 0, 0, 0};
float Curr_Z[]            = {0, 0, 0, 0};
float Curr_R[]            = {0, 0, 0, 0};
float Cap[]               = {0, 0, 0, 0};
float Cap_Z[]             = {0, 0, 0, 0};
float Cap_R[]             = {0, 0, 0, 0};
float Res[]               = {0, 0, 0, 0};
int   Watt[]              = {0, 0, 0, 0};
volatile int Minute[]     = {0, 0, 0, 0};
volatile int Minute_R[]   = {0, 0, 0, 0};
volatile int Minute_Z[]   = {0, 0, 0, 0};
int   Hour[]              = {0, 0, 0, 0};
int   Hour_R[]            = {0, 0, 0, 0};
int   Hour_Z[]            = {0, 0, 0, 0};
int   Sec[]               = {0, 0, 0, 0};
int   Sec_C[]             = {0, 0, 0, 0};
int   Proz[]              = {0, 0, 0, 0};
float Volt_Iz_B[]         = {0, 0, 0, 0};
float Volt_Iz_N[]         = {0, 0, 0, 0};
const byte  R_Z[]         = {12, 10, 8, 5};
const byte  R_N[]         = {11,  9, 7, 4};
const byte Read_Current[] = {0, 1, 2, 3};
byte  Akum_Flag[]         = {0, 0, 0, 0};
byte  Zar_Flag[]          = {0, 0, 0, 0};
byte  Raz_Flag[]          = {0, 0, 0, 0};
byte  Izm_Flag            = 0;
byte  Res_Flag            = 0;
byte  Cicl_Flag           = 0;
int   Limit_Raz[]         = {0, 3, 80};
byte  Limit_Flag          = 0;
byte  Limit_Ball          = 0;
byte  Lim_F               = 0;
byte  c                   = 0;
byte  ci                  = 0;
byte  Adress              = 3;
byte  Write               = 0;
#define SB_1                2
#define SB_2                3
#define SB_3                A6
#define SB_4                A7
byte  z                   = 0;
byte  r                   = 0;
byte  Blink[]             = {0, 0};
const byte  Red[]         = {0, 2, 6, 5};
const byte  Green[]       = {3, 1, 7, 4};
/*=======================================================================================================
                                  Преобразования слова в BCD значениe.
=======================================================================================================*/
int   High              = 0;                            // Переменная для хранения старшей тетрады.
int   Low               = 0;                            // Переменная для хранения младшей тетрады.
int   Num[]             = {0, 0, 0, 0, 0};
#define Zero for (byte i = 1; i <= 4; i++) Num[i] = 0; Low = Num[0]; High = 0; Num[4] = Low;
#define Zero_H Low = High; High = 0;
#define WORD_to_BCD  Zero while (Num[4] >= 10) NUM(4); Zero_H while (Num[3] >= 10) NUM(3); \
                     Zero_H while (Num[2] >= 10) NUM(2); Zero_H while (Num[1] >= 10) NUM(1); Num[0] = 0;
void NUM(byte Numb) {High++; Low -= 10; Num[Numb] = Low; Num[Numb - 1] = High;}
/*=======================================================================================================
                                              Чтение EEPROM
=======================================================================================================*/
void EEPROM_Read()
{
  for (int i = 0; i <= Adress; i++)
  {
    Limit_Raz[i] = EEPROM.read(i);                // считываем значение по текущему адресу EEPROM
  }
  Limit_Raz[0] = (Limit_Raz[1] * 100) + Limit_Raz[2];
}
/*=======================================================================================================
                                              Запись EEPROM
=======================================================================================================*/
void EEPROM_Write()
{
  for (int i = 0; i <= Adress; i++)
  {
    EEPROM.write(i, Limit_Raz[i]);
  }
  Serial.println(" << WRItE >> ");
}
/*=======================================================================================================
                                            Инициализация
=======================================================================================================*/
void setup()
{
  Serial.begin(115200);
  Wire.begin();

//  EEPROM_Write();
  EEPROM_Read();
  
  EXP8574.begin();
  for (byte i = 0; i <= 7; i++) {EXP8574.pinMode(i, OUTPUT); EXP8574.digitalWrite(i, HIGH);}
/*------------------------------------------------------------------------------------------------------/
                                              LGT8F328P
/*-----------------------------------------------------------------------------------------------------/
  analogReference(INTERNAL1V024);       // Установка напр. реф. 1.024V
  ADCSRA = (ADCSRA & 0xF8) | 0x03;      // Установить предделитель для АЦП (2,4,8,16,32,64,128) | 0x04;(16)
  // DAPCR - Регистер управления дифференциальным усилителем
  DAPCR = 0b11011000;                   // (11011000 ВКЛ, х16, AGND, АЦП с мультиплексиированием)((0b10000001 ВКЛ, х1, А2, А0)
  //ADCSRC - Регистр С управления и состояния АЦП
  bitSet(ADCSRC, DIFS);                 // DIFS = 1 - подключение АЦП к внутреннему дифференциальному усилителю
/*-----------------------------------------------------------------------------------------------------*/
  mcp.init();
  mcp.portMode(MCP23017Port::A, 0x00);                  // Port A as output
  mcp.portMode(MCP23017Port::B, 0x00);                  // Port B as output

  mcp.writeRegister(MCP23017Register::GPIO_A, 0x00);    // Reset port A 
  mcp.writeRegister(MCP23017Register::GPIO_B, 0x00);    // Reset port B
  
  Reset_Display(); Screen_Clear_0

  pinMode(SB_1, INPUT_PULLUP);
  pinMode(SB_2, INPUT_PULLUP);
  pinMode(SB_3, INPUT_PULLUP);
  pinMode(SB_4, INPUT_PULLUP);
  
  for (byte i = 0; i <= 3; i++) {pinMode(R_N[i], OUTPUT); pinMode(R_Z[i], OUTPUT);}
  for (byte i = 0; i <= 3; i++) {digitalWrite(R_N[i], LOW); digitalWrite(R_Z[i], LOW);}

  pinMode(Cooler, OUTPUT); digitalWrite(Cooler, LOW);
/*-----------------------------------------------------------------------------------------------------*/
  ads.setGain(GAIN_TWOTHIRDS);                          // Установка коэффициента усиления 2/3  

// ВОЗМОЖНЫЕ ВАРИАНТЫ УСТАНОВКИ КУ:                           
// ads.setGain(GAIN_TWOTHIRDS); | 2/3х | +/-6.144V | 1bit = 0.1875mV    |   
// ads.setGain(GAIN_ONE);       | 1х   | +/-4.096V | 1bit = 0.125mV     |  
// ads.setGain(GAIN_TWO);       | 2х   | +/-2.048V | 1bit = 0.0625mV    |  
// ads.setGain(GAIN_FOUR);      | 4х   | +/-1.024V | 1bit = 0.03125mV   |  
// ads.setGain(GAIN_EIGHT);     | 8х   | +/-0.512V | 1bit = 0.015625mV  |  
// ads.setGain(GAIN_SIXTEEN);   | 16х  | +/-0.256V | 1bit = 0.0078125mV |  

  ads.begin();                                          // Инициализация модуля ADS1115
/*-----------------------------------------------------------------------------------------------------*/
  Timer1.initialize(100000);                            // Timing for 100 ms
  Timer1.attachInterrupt(Timing_ISR);                   // Declare the interrupt serve routine : TimingISR
  MsTimer2::set(2, Timer_Interrupt);                    // Задаем период прерывания по таймеру 2 мс
  MsTimer2::start();                                    // Разрешаем прерывание по таймеру
}
/*=======================================================================================================
                                              Главный цикл
=======================================================================================================*/
void loop()
{
  if (Flag_Cels == 1) Read_DS18B20();
  Volt_Metr();
  Cap_Metr();
  Curr_Metr();
  Watt_Metr();
  Indic();
  if (Res_Flag == 1) Resis_Metr();
  Blinker_Leds();
  if (Write == 1)
  {
    for (byte w = 0; w <= 3; w++) Blink_Red(w, ON);
    delay(500);
    for (byte w = 0; w <= 3; w++) Blink_Red(w, OFF);
    Write = 0;
  }
  if (Cels[0] >= 40) digitalWrite(Cooler, HIGH);
  if (Cels[0] <= 37) digitalWrite(Cooler, LOW);
}
/*=====================================================================================================*/
