
/*=======================================================================================================
                                            Функции дисплея
/*=======================================================================================================
                A7  A6  A5  B0  B1  B2  B3   B4   B5   B6   B7   A4   A3   A2     A1      A0  <== MCP23017
  | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 |
  |GND|Vdd|Vo | A0|R/W| E |DB0|DB1|DB2| DB3| DB4| DB5| DB6| DB7| CS1| CS2| RST| Vee| A  | K  |
=======================================================================================================*/
#define Crystall_0  Write_A(0x1D); delayMicroseconds(1);
#define Strob_Reset Write_A(0x19); delayMicroseconds(1); Write_A(0x1D); delayMicroseconds(1);
#define Strob_Data  bitSet(W, 5); Write_A(W); delayMicroseconds(1); bitClear(W, 5); Write_A(W); delayMicroseconds(1);
/*=======================================================================================================
                                      Функция вывода данных в MCP23017
=======================================================================================================*/
void Write_A(byte A) {mcp.writeRegister(MCP23017Register::GPIO_A, A);}
void Write_B(byte B) {mcp.writeRegister(MCP23017Register::GPIO_B, B);}
/*=======================================================================================================
                                        Функция записи данных в экран
=======================================================================================================*/
void Write_Data_Screen(byte Tab_Sim)
{
  Write_B(Ind);                                       // Выводим данные в регистр
  set_Page();                                         // Установка страницы
                     
  while (ColSimb > 0)                                 // номер колонки символа
  {
    if (Tab_Sim ==  8) {Digit[0] = Digit[ColSimb]; Write_Simbol_8x8();}
//    if (Tab_Sim == 15) {Digit_1[0] = Digit_1[ColSimb]; Write_Simbol_16x24();}
    ColSimb--;
  }
}
/*=======================================================================================================
                                        Функция записи символа в экран
=======================================================================================================*/
void Write_Simbol_8x8()
{
  while (ColStolb_1 < 7)
  {
    Write_B(Ind = ColStolb[0]);                         // Выводим данные в регистр
    set_Colon();                                        // Установка колонки
    Tab_Simb_8x8();
    Write_B(Ind = Out_Dat[0]);                          // Выводим данные в регистр
    Write_Bit();
    ColStolb_1++;
    ColStolb[0]--;
  }
  ColStolb_1 = 0;
}
/*=======================================================================================================
                                            Функция строб записи в экран
=======================================================================================================*/
void Write_Strob_Screen()
{
  bitSet(W, 7); bitSet(W, 5); Write_A(W); delayMicroseconds(1); 
  bitClear(W, 5); Write_A(W); delayMicroseconds(1); bitClear(W, 7); 
}
/*=======================================================================================================
                                            Функция записи бита данных
=======================================================================================================*/
void Write_Bit() {Write_Strob_Screen();}    // Строб данных (B3) A5
/*=======================================================================================================
                                            Функция установки колонки
=======================================================================================================*/
void set_Colon()
{
  bitSet(Ind, 6);                           // set Colonky 40(stolbec).
  Write_B(Ind);                             // Установка колонки
  Strob_Data                                // Строб данных (B3) A5.
}
/*=======================================================================================================
                                            Функция установки страницы
=======================================================================================================*/
void set_Page()
{
  Write_B(Ind += 0xB8);                     // Установка страницы
  Strob_Data                                // Строб данных (B3) A5.
}
/*=======================================================================================================
                                    Функция очистки экрана
=======================================================================================================*/
void Clrear_Screen(void)
{
  byte c[] = {0,0,0,0};
  byte a = 2;
  Crystall_0                                // Включили кристаллы
/*-----------------------------------------------------------------------------------------------------*/
  if (Clr_Scr == 1) a = 1;
  for (c[1] = a; c[1] >= 1; c[1]--)         // Установка номера кристалла
  {
    for (c[2] = 8; c[2] >= 1; c[2]--)       // Установка номера страницы
    {
      Ind = c[2] - 1;                       // Номер страницы
      set_Page();
      for (c[3] = 0; c[3] <= 0x3F ; c[3]++) // Установка номера столба
      {
        Ind = c[3];                         // Установка столба
        set_Colon();
        Ind = 0;                            // Пиксель = 0(погашен). data <- 0
/*-----------------------------------------------------------------------------------------------------*/
        if (Power == 1)                     // Рисуем 
        {
          if (c[3] == 0x3F) Ind = 0xFF;     // Лево
          if (c[3] == 0x1F) Ind = 0xFF;     // Середина
        }
/*-----------------------------------------------------------------------------------------------------*/
        Write_B(Ind);                       // Выводим данные
        Write_Bit();                        // Записываем данные
      }
/*-----------------------------------------------------------------------------------------------------*/
    }
    switch (c[1])                           // Включили кристалл
    {
      case 0: Crystall_0; break;
      case 1: Crystall_1; break;
      case 2: Crystall_2; break;
    }
/*-----------------------------------------------------------------------------------------------------*/
  }  
}
/*=======================================================================================================
                                          Функция сброса дисплея
=======================================================================================================*/
void Reset_Display(void)
{
  Crystall_0                                // Выбор кристала
  Strob_Reset                               // Строб сброса
  Write_B(Ind = 0x3F);                      // Включаем дисплей
  Strob_Data                                // Строб данных A5
}
/*=====================================================================================================*/
