/*=======================================================================================================
                                              Измеряем напряжение
=======================================================================================================*/
void Volt_Metr()
{
  for (byte i = 0; i <= 3; i++) 
  {
    Adc[i]  = ads.readADC_SingleEnded(i);
    Volt[i] = float(Adc[i]) * 0.1875 / 10.0;
    Proz[i] = map(Volt[i], 270, 420, 0, 100);
    if (Proz[i] <= 0) 
    {
      Proz[i] = 0; Akum_Flag[i] = 0; Volt[i] = 0;
/*-----------------------------------------------------------------------------------------------------*/
      switch (i)                                          // Выключили зеленый
      {
        case 0: Blink_Green(i, OFF); break;
        case 1: Blink_Green(i, OFF); break;
        case 2: Blink_Green(i, OFF); break;
        case 3: Blink_Green(i, OFF); break;
      }
    }
/*-----------------------------------------------------------------------------------------------------*/
    else 
    {
      Akum_Flag[i] = 1;
      Serial.print(" : Akum_F_"); Serial.print(i); Serial.print(" = "); Serial.print(Akum_Flag[i]);
      if (Blink[0] == 0)
      {
        switch (i)                                         // Включили зеленый
        {
          case 0: Blink_Green(i, ON); break;
          case 1: Blink_Green(i, ON); break;
          case 2: Blink_Green(i, ON); break;
          case 3: Blink_Green(i, ON); break;
        }
      }
    }
  }
/*-----------------------------------------------------------------------------------------------------*/
  Serial.print(" : Cels = "); Serial.println(Cels[0]);
  for (byte i; i <= 3; i++) {Serial.print(" : Volt_");Serial.print(i); Serial.print(" = "); Serial.print(Volt[i] / 100, 4);}
  Serial.println(" ");
/*-----------------------------------------------------------------------------------------------------*/
}
/*=======================================================================================================
                                              Измеряем ток
=======================================================================================================*/
void Curr_Metr()
{
  for (byte i = 0; i <= 3; i++)  Curr_O[i] = 0;
  for (byte i = 0; i <= 3; i++) 
  {
    if (Zar_Flag[i] == 1)
    {
      Curr[i] = analogRead(Read_Current[i]);
      Curr_Z[i] = ((Curr[i] * (5.0 / 1023.0) * Zc[i]) * 1000 - 20);
      Curr_O[i] = Curr_Z[i];
      Serial.print(" : Cur_Z_"); Serial.print(i); Serial.print(" = "); Serial.print(Curr_Z[i]);
    }
    if (Raz_Flag[i] == 1)
    {
      Curr[i] = analogRead(Read_Current[i]);
      Curr_R[i] = ((Curr[i] * (5.0 / 1023.0) * Rc[i]) * 1000 - 20);
      Curr_O[i] = Curr_R[i];
      Serial.print(" : Cur_R_"); Serial.print(i); Serial.print(" = "); Serial.print(Curr_R[i]);
    }
    if (Curr[i] <= 0.02) Curr[i] = 0.00;
    if (Raz_Flag[i] == 0 && Zar_Flag[i] == 0) Curr[i] = 0.00;
//    Serial.print(" : Curr = "); Serial.print(Curr[i]);
  }
  Serial.println(" ");
}
/*=======================================================================================================
                                              Измеряем емкость
=======================================================================================================*/
void Cap_Metr()
{
  for (byte i = 0; i <= 3; i++) 
  {
    if (Zar_Flag[i] == 1) {Cap_Z[i] += Curr_Z[i] / 1500; Cap[i] = Cap_Z[i];}
    if (Raz_Flag[i] == 1) {Cap_R[i] += Curr_R[i] / 1500; Cap[i] = Cap_R[i];}
  }
  for (byte ii = 0; ii <= 3; ii++) {Serial.print(" : Cap_Z_");Serial.print(ii); Serial.print(" = "); Serial.print(Cap_Z[ii]);}
  Serial.println(" ");
  for (byte ii = 0; ii <= 3; ii++) {Serial.print(" : Cap_R_");Serial.print(ii); Serial.print(" = "); Serial.print(Cap_R[ii]);}
  Serial.println(" ");
}
/*=======================================================================================================
                                              Измеряем мощность
=======================================================================================================*/
void Watt_Metr()
{
  for (byte i = 0; i <= 3; i++) 
  {
    Watt[i] = Volt[i] * (Curr[i] / 100);
//    Serial.print(" : Watt = "); Serial.print(Watt[i], 3);
  }
//  Serial.println(" "); Serial.println(" ");
}
/*=======================================================================================================
                                              Вычисляем сопротивление
=======================================================================================================*/
void Resis_Metr()
{
  byte Inp = 0; Izm_Flag = 0;
Loop:
  if (Akum_Flag[Inp] == 0) {Inp++; goto Loop;}
  switch (Izm_Flag)
  {
    case 0: 
            Volt_Metr(); Volt_Iz_B[Inp] = Volt[Inp];
            Raz(Inp, 1);
            Sec[2] = 0; Izm_Flag = 1;
            switch (Inp)
            {
              case 0: Blink_Red(Inp, ON); Blink_Green(Inp, ON); break;
              case 1: Blink_Red(Inp, ON); Blink_Green(Inp, ON); break;
              case 2: Blink_Red(Inp, ON); Blink_Green(Inp, ON); break;
              case 3: Blink_Red(Inp, ON); Blink_Green(Inp, ON); break;
            }
    break;
    case 2:
            Volt_Metr(); Volt_Iz_N[Inp] = Volt[Inp];
            Curr[Inp] = analogRead(Read_Current[Inp]);
            Curr[Inp] = Curr[Inp] * (5.0 / 1023.0) * Rc[Inp];
            Res[Inp] = (Volt_Iz_B[Inp] - Volt_Iz_N[Inp]) / Curr[Inp];
            switch (Inp)
            {
              case 0: Blink_Red(Inp, OFF); Blink_Green(Inp, ON); break;
              case 1: Blink_Red(Inp, OFF); Blink_Green(Inp, ON); break;
              case 2: Blink_Red(Inp, OFF); Blink_Green(Inp, ON); break;
              case 3: Blink_Red(Inp, OFF); Blink_Green(Inp, ON); break;
            }
            Serial.print(" : Res_");Serial.print(Inp); Serial.print(" = "); Serial.println(Res[Inp]);
            Raz(Inp, 0);
            Izm_Flag = 0; Inp++;
            Indic();
    break;
  }
  if (Inp >= 4) {Res_Flag = 0; goto End_Loop;}
  goto Loop;
End_Loop:
  Serial.println(" ");                  // Здесь должна быть любая команда
}
/*=====================================================================================================*/
